<script lang="ts">
import Vue, { PropType } from 'vue';
import {
  CtfEntry,
  CtfTheSourceArticlePage,
  CtfTheSourceCategory,
} from '~/models';
import { getUrlFromContentfulImage } from '~/common/util';
import { THE_SOURCE_TYPES } from '~/common/constants';
import TheSourceResources from '~/components/the-source/resources.vue';

export default Vue.extend({
  name: 'TheSourceLandingCategory',
  components: { TheSourceResources },
  props: {
    category: {
      type: Object as PropType<CtfEntry<CtfTheSourceCategory>>,
      required: true,
    },
    parentIndex: {
      type: Number,
      required: false,
      default: 0,
    },
  },
  data() {
    return {
      mostRecentArticles: [],
      types: THE_SOURCE_TYPES,
    };
  },
  async fetch() {
    this.mostRecentArticles =
      await this.$theSourceService.getArticlesByCategory(
        this.category.sys.id,
        3,
      );

    this.mostRecentArticles = this.mostRecentArticles.map((article) => ({
      ...article,
      isHighlighted: false,
    }));
  },
  methods: {
    getArticleImage(
      article: CtfEntry<CtfTheSourceArticlePage>,
      mostRecent: boolean,
    ) {
      const width = mostRecent ? 1460 : 340;
      const height = mostRecent ? 760 : 180;

      return getUrlFromContentfulImage(article.fields.heroImage, width, height);
    },
    getAlt(article: CtfEntry<CtfTheSourceArticlePage>) {
      return article.fields?.heroImage?.fields?.description;
    },
  },
});
</script>

<template>
  <div
    :class="[
      'ts-landing-category',
      { 'ts-landing-category--surface-bg': parentIndex % 2 !== 0 },
    ]"
  >
    <SlpContainer>
      <div class="slp-px-md-16">
        <SlpTypography tag="h1" variant="all-caps" class="slp-mb-8">{{
          $t('articles.category')
        }}</SlpTypography>
        <SlpButton :href="`/${category.fields.slug}`" variant="tertiary">
          <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-8">{{
            category.fields.title
          }}</SlpTypography>
        </SlpButton>
      </div>
      <SlpRow>
        <!-- CATEGORY's MOST RECENT ARTICLES START -->
        <!-- The first articles is highlighted using the index as validator-->
        <SlpColumn :cols="8" class="slp-pr-md-24">
          <div
            v-for="(article, index) in mostRecentArticles"
            :key="article.sys.id"
            :class="
              index === 0
                ? 'ts-landing-category__most-recent'
                : 'ts-landing-category__article'
            "
          >
            <SlpButton
              :href="`/${article.fields.slug}/`"
              variant="ghost"
              class="ts-landing-category__image"
              @mouseover.native="article.isHighlighted = true"
              @mouseleave.native="article.isHighlighted = false"
            >
              <img
                v-if="article.fields?.heroImage"
                :src="getArticleImage(article, index === 0)"
                :alt="getAlt(article)"
              />
            </SlpButton>
            <div class="ts-landing-category__details">
              <div class="slp-flex">
                <SlpIcon
                  v-if="article.fields.type !== types.REGULAR"
                  name="lock"
                  variant="product"
                  class="slp-mr-4"
                />
                <SlpTypography tag="h5" variant="all-caps">{{
                  $t(
                    `articles.${article.fields.type.toLowerCase() || 'article'}`,
                  )
                }}</SlpTypography>
              </div>
              <SlpButton
                :href="`/${article.fields.slug}/`"
                variant="tertiary"
                :class="{
                  'ts-landing-category--active': article.isHighlighted,
                }"
              >
                <SlpTypography
                  tag="h2"
                  :variant="`${index === 0 ? 'heading3-bold' : 'heading5-bold'}`"
                  class="ts-landing-category__headline"
                  >{{ article.fields?.headline }}
                </SlpTypography>
              </SlpButton>
              <SlpTypography
                v-if="article.fields?.description && index === 0"
                tag="p"
                variant="body1"
                class="slp-mb-8"
              >
                {{ article.fields.description }}
              </SlpTypography>
              <div class="ts-landing-category__btn-group">
                <SlpButton
                  v-if="category"
                  :href="`/${category.fields.slug}/`"
                  variant="tertiary"
                >
                  <SlpTypography tag="span" variant="body3-bold"
                    >{{ category.fields.title }}
                  </SlpTypography>
                </SlpButton>
                <span v-if="article.fields.author" class="separator"></span>
                <SlpButton
                  v-if="article.fields?.author"
                  :href="`/${article.fields.author.fields?.slug}/`"
                  variant="tertiary"
                >
                  <SlpTypography tag="span" variant="body3-bold">
                    {{ article.fields.author.fields.name }}
                  </SlpTypography>
                </SlpButton>
              </div>
            </div>
          </div>
          <SlpButton
            class="ts-landing-category__browse"
            variant="primary"
            :href="`/${category.fields.slug}/`"
          >
            {{ $t('articles.browse') }}
          </SlpButton>
        </SlpColumn>
        <!-- CATEGORY's MOST RECENT ARTICLES END -->
        <SlpColumn
          v-if="category.fields.gatedAssets?.length"
          :cols="4"
          class="w-100"
        >
          <TheSourceResources
            :resources="category.fields.gatedAssets"
            :surface-bg="parentIndex % 2 === 0"
          />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.separator {
  border-left: 1px solid $color-surface-400;
  height: 12px;
  margin: 0 $spacing-8;
}

.ts-landing-category {
  padding: $spacing-32 0;
  position: relative;

  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0;
  }

  .slp-btn {
    padding: 0;
    text-align: start;

    &:hover {
      color: $color-text-link-100;
      text-decoration-color: $color-text-link-100;
    }
  }

  &__image {
    padding: 0;
    margin-bottom: $spacing-8;

    img {
      border-radius: 8px;
    }
  }

  &--active {
    color: $color-text-link-100;
    text-decoration-color: $color-text-link-100;
    text-decoration: underline;
  }

  &__headline {
    margin-bottom: $spacing-8;
  }

  &--surface-bg {
    background-color: $color-surface-100 !important;
  }

  &__article {
    flex-direction: row-reverse;
    align-items: center;
    justify-content: space-between;
    padding: $spacing-24 0;

    @media (width >= $breakpoint-md) {
      padding: $spacing-24;
    }

    .ts-landing-category__details {
      margin-right: $spacing-16;
    }

    @media (width <= 430px), ($breakpoint-md <= width <= $breakpoint-lg) {
      .ts-landing-category__btn-group {
        flex-direction: column;
        align-items: flex-start;
      }

      .separator {
        display: none;
      }
    }

    .ts-landing-category__image {
      min-width: 100px;
      max-width: 100px;
      height: 100px;
      max-height: 100px;

      img {
        width: 100%;
        height: 100%;
        max-height: 100px;
        object-fit: cover;
        overflow-clip-margin: unset;

        @media (width >= $breakpoint-md) {
          object-fit: unset;
        }
      }

      @media (min-width: $breakpoint-sm) {
        min-width: 186px;
        max-height: 100px;
        max-width: 186px;
      }
    }
  }

  &__most-recent {
    flex-direction: column;
    padding: $spacing-16 0;

    @media (width >= $breakpoint-md) {
      padding-top: $spacing-24;
    }

    .ts-landing-category__details {
      @media (width >= $breakpoint-md) {
        padding: $spacing-24;
      }
    }

    img {
      border-radius: 8px;
      max-height: 383px;
      width: 100%;
      max-width: 750px;
    }
  }

  &__article,
  &__most-recent {
    display: flex;
    border-bottom: 1px solid $color-surface-300;
  }

  &__btn-group {
    display: flex;
    align-items: center;
    text-align: start;
  }

  &__browse {
    width: 100%;
    margin-top: $spacing-24;
    justify-content: center;
    padding: 11px $spacing-16 !important;

    &:hover {
      color: $color-primary-200 !important;
    }
  }
}
</style>
